# List of Examples

The following is a list of examples present in this book.

### Chapters examples

* Getting started

    * [Hello World](../02/)
        - ["Hello World!"](../edit.html#02/hello_world.frag)

    * [Uniforms](../03/)
        - [u_time](../edit.html#03/time.frag)
        - [gl_FragCoord](../edit.html#03/space.frag)

* Algorithmic drawing

    * [Shaping functions](../05/)
        - [Linear Interpolation](../edit.html#05/linear.frag)
        - [Exponential Interpolation](../edit.html#05/expo.frag)
        - [Step function](../edit.html#05/step.frag)
        - [Smoothstep function](../edit.html#05/smoothstep.frag)
        - [Iñigo Quiles's Impulse](../edit.html#05/impulse.frag)
        - [Iñigo Quiles's Cubic Pulse](../edit.html#05/cubicpulse.frag)
        - [Iñigo Quiles's Exponential Step](../edit.html#05/expstep.frag)
        - [Iñigo Quiles's Parabola](../edit.html#05/parabola.frag)
        - [Iñigo Quiles's Power Curve](../edit.html#05/pcurve.frag)
        - [Easing functions](../edit.html#05/easing.frag)
        - [Stepwise function](../edit.html#examples/05/stepwise.frag)
        - [Drawing multiple shaping functions](../edit.html#examples/05/draw-multi-shaping-func.frag)
        - By [Kynd](https://twitter.com/kyndinfo)'s extra examples: [quadratic bezier](../edit.html?log=160208105810), [cubic bezier 1](../edit.html?log=160208105716) and [cubic bezier 2](../edit.html?log=160208105702)

    * [Color](../06/)
        - [Mix](../edit.html#06/mix.frag)
        - [Gradient](../edit.html#06/gradient.frag)
        - [HSB](../edit.html#06/hsb.frag)
        - [HSB - Color Wheel](../edit.html#06/hsb-colorwheel.frag)

    * [Shapes](../07/)
        - Rectangle: [making](../edit.html#07/rect-making.frag), [function](../edit.html#07/rect.frag) and [distance-field](../edit.html#07/rect-df.frag)
        - Circle: [making](../edit.html#07/circle-making.frag) and [function](../edit.html#07/circle.frag)
        - [Distance-field Batman](../edit.html#07/batman.frag)
        - [Line](../edit.html#07/line.frag)
        - [Cross](../edit.html#07/cross.frag)
        - [Polar shapes](../edit.html#07/polar.frag)
        - [Polar Poligons](../edit.html#07/shapes.frag)
        - Composition: [Arrow](../edit.html#07/arrow.frag)
        - By [Kynd](https://twitter.com/kyndinfo)'s extra examples: [distance field shapes](../edit.html?log=160131053729), [distance field shape transitions](../edit.html?log=160131053646), [distance field metaball](../edit.html?log=160208110000)

    * [Matrix](../08/)
        - [cross](../edit.html#08/cross.frag)
        - [translate](../edit.html#08/cross-translate.frag)
        - [rotate](../edit.html#08/cross-rotate.frag)
        - [scale](../edit.html#08/cross-scale.frag)

    * [Patterns](../09/)
        - Grid: [making](../edit.html#09/grid-making.frag), [final](../edit.html#09/grid.frag), [Side grid](../edit.html#09/grid-side.frag) and [grid of +](../edit.html#09/cross.frag)
        - [Lines](../edit.html#09/lines.frag), [waves](../edit.html#09/lines-wave.frag) & [zigzag](../edit.html#09/zigzag.frag)
        - [Checks](../edit.html#09/checks.frag)
        - [Diamond tiles](../edit.html#09/diamondtiles.frag)
        - [Bricks](../edit.html#09/bricks.frag)
        - Dots: [0](../edit.html#09/dots.frag), [1](../edit.html#09/dots1.frag), [2](../edit.html#09/dots2.frag), [3](../edit.html#09/dots3.frag), [4](../edit.html#09/dots4.frag), [5](../edit.html#09/dots5.frag) and [marching dots](../edit.html#09/marching_dots.frag)
        - [Rotated tiles](../edit.html#09/rotatedtiles.frag)
        - [Nuts pattern](../edit.html#09/nuts.frag)
        - [Mirror tiles](../edit.html#09/mirrortiles.frag)
        - [Truchet](../edit.html#09/truchet.frag)
        - [Deco](../edit.html#09/deco.frag)
        - [I Ching](../edit.html#09/iching-01.frag)

* Generative designs

    * [Random](../10/)
        - [1D Random](../edit.html#10/1d-random.frag)
        - [2D Random](../edit.html#10/2d-random.frag)
        - [Random Mosaic](../edit.html#10/2d-random-mosaic.frag)
        - [Random Dots](../edit.html#10/2d-random-dots.frag)
        - [Random Truchet](../edit.html#10/2d-random-truchet.frag)
        - Ikeda's style: [test pattern](../edit.html#10/ikeda-00.frag), [wave](../edit.html#10/ikeda-01.frag),[test pattern](../edit.html#10/ikeda-02.frag), [data path](../edit.html#10/ikeda-03.frag) and [data defrag](../edit.html#10/ikeda-04.frag).
        - [Matrix](../edit.html#10/matrix.frag)
        - [Digits](../edit.html#10/ikeda-digits.frag)
        - [Random Grid](../edit.html#10/ikeda-simple-grid.frag)
        - [Random Numbered Grid](../edit.html#10/ikeda-numered-grid.frag)
        - [Random - I Ching](../edit.html#10/iching-02.frag)

    * [Noise](../11/)
        - Value Noise: [1D](../edit.html#11/1d-noise.frag), [2D](../edit.html#11/2d-noise.frag) & [3D](../edit.html#11/3d-noise.frag)
        - Gradient Noise: [2D](../edit.html#11/2d-gnoise.frag)
        - Classic Perlin Noise: [2D](../edit.html#11/2d-pnoise.frag) & [3D](../edit.html#11/3d-pnoise.frag)
        - [Simplex Grid](../edit.html#11/simplex-grid.frag)
        - Simplex Noise: [2D](../edit.html#11/2d-snoise.frag) & [3D](../edit.html#11/3d-snoise.frag)
        - Generative textures: [wood](../edit.html#11/wood.frag), [splatter](../edit.html#11/splatter.frag), [lava lamp](../edit.html#11/lava-lamp.frag)
        - [I Ching with Noise](../edit.html#11/iching-03.frag)

### Advance

* [Moon](../edit.html#examples/moon.frag&examples/images/moon-texture.jpg)
* [Matrix](../edit.html#08/matrix.frag)
* I Ching series:  [pattern](../edit.html#09/iching-01.frag), [random](../edit.html#10/iching-02.frag), [with noise](../edit.html#11/iching-03.frag)
* Ikeda's series: [test pattern](../edit.html#10/ikeda-00.frag), [data path](../edit.html#10/ikeda-03.frag), [data defrag](../edit.html#10/ikeda-04.frag), [digits](../edit.html#10/ikeda-digits.frag), [radar](../edit.html#10/ikeda-simple-grid.frag) and [numered grid](../edit.html#10/ikeda-numered-grid.frag)

### Students Work

 * Expceserices from them [Color Chapter](../06/)

	- [Light](../edit.html#examples/06/behrn916-light.frag) by Nima Behravan
	- [Turner Sunset](../edit.html#examples/06/dothh489-sunset.frag) by Hang Do Thi Duc
	- [Villareal instalation](../edit.html#examples/06/dothh489-villareal.frag) by Hang Do Thi Duc 
	- [Turner Sunset](../edit.html#examples/06/henrt555-turner.frag) by Tyler Henry
	- [Villareal instalation 1](../edit.html#examples/06/mahau289-villareal1.frag) by Udit Mahajan
	- [Villareal instalation 2](../edit.html#examples/06/mahau289-villareal2.frag) by Udit Mahajan
	- [Sunrise/Sunset](../edit.html#examples/06/randj063-sunset.frag) by Jaskirat Randhawa
	- [Villareal instalation](../edit.html#examples/06/tothn598-villareal.frag) by Nitcha Tothong
	- [Villareal instalation](../edit.html#examples/06/wangl073-villareal.frag) by Luobin Wang 
